<template>
  <client-only>
    <v-btn
      :variant="props.btnVariant"
      color="primary"
      :loading="loading"
      @click="download"
    >
      <slot> Download </slot>
      <v-icon end>mdi-download</v-icon>
    </v-btn>
  </client-only>
</template>

<script setup lang="ts">
import fileSave from "file-saver";
import * as xlsx from "xlsx";

const props = withDefaults(
  defineProps<{
    text: string | (() => Promise<string>);
    filename?: string;
    btnVariant?: "text" | "flat" | "elevated" | "tonal" | "outlined" | "plain";
    filetype?: "xlsx";
  }>(),
  {
    filename: "download.txt",
    btnVariant: "text",
    filetype: undefined,
  },
);

const loading = ref(false);

// Convert string to ArrayBuffer
const s2ab = (s: string) => {
  const buf = new ArrayBuffer(s.length);
  const view = new Uint8Array(buf);
  for (let i = 0; i < s.length; i++) view[i] = s.charCodeAt(i) & 0xff;
  return buf;
};

const download = async () => {
  let blob;
  let text;
  if (typeof props.text === "function") {
    loading.value = true;
    text = await props.text();
    loading.value = false;
  } else {
    text = props.text;
  }
  if (props.filetype === "xlsx") {
    const wb = xlsx.read(text, { type: "string" });
    const xlsxFile = xlsx.write(wb, { bookType: "xlsx", type: "binary" });
    blob = new Blob([s2ab(xlsxFile)], {
      type: "application/octet-stream",
    });
  } else {
    blob = new Blob([text], {
      type: "text/plain;charset=utf-8",
    });
  }
  fileSave.saveAs(blob, props.filename);
};
</script>
